/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 21/05/2019
 --------------------------------------------------------
*/
package com.portofolio.service;

import  java.util.Map;

import org.springframework.beans.BeanUtils;
import  org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import  org.springframework.stereotype.Service;
import  org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.ProfileConfigDesignDao;
import com.portofolio.dto.ProfileConfigDesignDto;
import com.portofolio.entity.ProfileConfigDesign;
import com.portofolio.entity.vo.ProfileConfigDesignId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Service("profileConfigDesignService")
public class ProfileConfigDesignService extends BaseServiceImpl {
    
    @Lazy
    @Autowired
    private ProfileConfigDesignDao profileconfigdesignDao;
    
    @Lazy
    @Autowired
    private LanguageService languageService;
    
    
    @Transactional
	public Map<String, Object> save(ProfileConfigDesignDto profileconfigdesignDto) {
		result.clear();
		ProfileConfigDesignId id = new ProfileConfigDesignId();
		id.setKdModulAplikasi(profileconfigdesignDto.getKdModulAplikasi());
		id.setKdProfile(profileconfigdesignDto.getKdProfile());
		id.setKdVersion(profileconfigdesignDto.getKdVersion());
		ProfileConfigDesign profileconfigdesign = CommonUtil.findOne(profileconfigdesignDao, id);
		if (CommonUtil.isNullOrEmpty(profileconfigdesign)) {
			profileconfigdesign = new ProfileConfigDesign();
			BeanUtils.copyProperties(profileconfigdesignDto, profileconfigdesign);
			profileconfigdesign.setNoRec(generateUuid32());
			profileconfigdesign.setVersion(1);
			profileconfigdesign.setId(id);
			profileconfigdesign = profileconfigdesignDao.save(profileconfigdesign);
		} else {
			throw new InfoException(languageService.getTranslateByKey("profileConfigDesign.message.dataAlreadyExist"));
		}
		result.put("profileConfigDesign", profileconfigdesign);
		resultCreated();

		return result;
	}
    
    @Transactional
	public Map<String, Object> update(ProfileConfigDesignDto profileconfigdesignDto, Integer version) {
		result.clear();
		ProfileConfigDesignId id = new ProfileConfigDesignId();
		id.setKdModulAplikasi(profileconfigdesignDto.getKdModulAplikasi());
		id.setKdProfile(getKdProfile());
		id.setKdVersion(profileconfigdesignDto.getKdVersion());

		ProfileConfigDesign profileconfigdesign = CommonUtil.findOne(profileconfigdesignDao, id);
		if (CommonUtil.isNotNullOrEmpty(profileconfigdesign)) {
			if (version < profileconfigdesign.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(profileconfigdesignDto, profileconfigdesign);
			profileconfigdesign = profileconfigdesignDao.save(profileconfigdesign);
			result.put("profileConfigDesign", profileconfigdesign);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}
    
    
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaModulAplikasi,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaModulAplikasi)) {
			pageRes = profileconfigdesignDao.findAllList(statusEnabled, pageReq);
		} else {
			pageRes = profileconfigdesignDao.findAllList(namaModulAplikasi, statusEnabled, pageReq);
		}
		result.put("profileConfigDesign", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}
    
    
	public Map<String, Object> findById(String kdModulAplikasi, Integer kdVersion, Integer kdProfile) {
		result.clear();
		result.put("profileConfigDesign",profileconfigdesignDao.findById(kdProfile, kdModulAplikasi, kdVersion, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();

		return result;
	}
    
    @Transactional
	public Map<String, Object> deleteById(String kdModulAplikasi, Integer kdVersion, Integer kdProfile,
			Integer version) {

		result.clear();
		ProfileConfigDesignId id = new ProfileConfigDesignId();
		id.setKdModulAplikasi(kdModulAplikasi);
		id.setKdProfile(kdProfile);
		id.setKdVersion(kdVersion);

		ProfileConfigDesign profileconfigdesign = CommonUtil.findOne(profileconfigdesignDao, id);
		if (CommonUtil.isNotNullOrEmpty(profileconfigdesign)) {
			if (version < profileconfigdesign.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			profileconfigdesign.setStatusEnabled(false);
			profileconfigdesign.setVersion(version);
			profileconfigdesign = profileconfigdesignDao.save(profileconfigdesign);
			result.put("profileConfigDesign", profileconfigdesign);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;

	}
    


}
